/*
 * Copyright (c) 2004, 2005, 2006 BLADOX, s.r.o.
 * All Rights Reserved.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE BLADOX OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 * THE POSSIBILITY OF SUCH DAMAGE.  
 */

#ifndef _TURBO_TWIN_H_
#define _TURBO_TWIN_H_

#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif

extern u8 twin_on(u8 * atr_buf);
extern void twin_clk_on();
extern void twin_clk_off();
extern u8 twin_txrx(u8 tx_len, u8 *buf, u8 rx_len);
extern u16 twin_sim(u8 ins, u8 p1, u8 * p2, u8 p3, u8 *buf);
extern u16 twin_t1_apdu(u16 tx_len, u8 *buf);

/**
\ingroup api_twin

Turn twin chip off.

*/

extern void twin_off();


#ifdef __cplusplus
}
#endif

#endif
